program blablah;

uses fm32;

type
    screen=array[0..65534] of byte;     {64k data segment tipo}

var
    flu1     :^screen;
var fhand    :word;
    xaddr    :longint;
    buf_point:pointer;
    err      :byte;

begin
     new(flu1);
     buf_point:=addr(flu1^);

     start;
     xmshandle:=XMSalloc(1024);          {allocate 1024 kb}

     if (xmshandle=$ffff) then
     begin
          writeln('Error allocating continuous block of 1024KB');
          exit;
     end;

     xmsaddress:=XMSlock(xmshandle);

  {****
   following we demonstrate how to open and load file into xms
   of course ye could replace the filename and file size for more
   testings!
   ****
  }

     if open_file32('fm32.tpu'+char(0),fhand)=1 then
     begin
          exit;
     end;

     if loadhigh_f32(fhand,buf_point,3552,xmsaddress)=1 then
     begin
          writeln('No file encontrado...');
          exit;
     end;


  {****
   the following code writes 1024kb to xms then read 1024kb while
   comparing with the data written to check for validity
   the pattern written is 12345678h.
   ****
  }

  asm
	xor ax,ax
	mov es,ax
        db 66h,33h,0ffh                         {xor edi,edi}
        mov bx,word ptr xmsaddress[2]
        db 66h,0c1h,0e3h,10h                    {shl ebx,16 }
        mov bx,word ptr xmsaddress[0]

        db 66h,0b8h,78h,56h,34h,12h             {mov eax,12345678h}

	@XFILL:
        db 26h,67h,66h,89h,04h,1fh              {mov es,[ebx+edi],eax}
        db 66h,83h,0c7h,04h                     {add edi,4}
        db 66h,81h,0ffh,00h,00h,10h,00h         {cmp edi,100000h}
        jb @XFILL
        db 66h,33h,0ffh                         {xor edi,edi}
        db 66h,0b8h,78h,56h,34h,10h             {mov eax,12345678h}
  @XCHK:
        db 26h,67h,66h,39h,04h,1fh              {cmp es:[ebx+edi],eax}
	jne @READERR
        db 66h,83h,0c7h,04h                     {add edi,4}
        db 66h,81h,0ffh,00h,00h,10h,00h         {cmp edi,100000h}
	jb @XCHK
	jmp @NOERRORS
  @READERR:
        mov err,1
  @NOERRORS:
        end;


  {report error}
  if err=1 then
     writeln('la memory revisar: malo!')
  else
      writeln('la memory revisar: buenas!');

  {closing up}

  XMSunlock(xmshandle);
  if XMSfree(xmshandle)=1  then
     writeln('XMS freed...')
  else
      writeln('Unable to free XMS...');
    dispose(flu1);

end.

